# bridge_client

### Usage

#### Bridge Interface Define

```dart
import 'package:meta/meta.dart';
import 'package:bd_bridge_client/annotation.dart';
import 'package:bd_bridge_client/client.dart';

part "ui.g.dart";

@Bridge('UI')
mixin UI on BridgeModule {
  @BridgeMethod()
  Future<void> toast({String message});
}
```

#### Run Codegen

``` shell
flutter packages pub run build_runner build
```

Generate ui.g.dart file part: 

``` dart
// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'ui.dart';

// **************************************************************************
// BridgeGenerator
// **************************************************************************

class UIBridge extends BridgeModule with UI {
  UIBridge({BridgeClient client}) : super(client: client);
  Future<void> toast({
    String message,
  }) {
    var _$params = {
      'message': message,
    };
    var _$result = client.getData<void>('TTRUI.toast', params: _$params);
    return _$result;
  }
}
```

#### Usage in Dart

``` dart
bridge.ui.toast(message: 'Send Message~');
```

#### Get In Native Side

``` java
public class ToastMethod extends BridgeMethods.PublicMethod {
    @Override
    public Single<IBridgeResult> call(IBridgeContext context, JsonObject params) {
        Toast.makeText(getApplicationContext(), params.get("message").getAsString(), Toast.LENGTH_SHORT).show();
        return BridgeResult.createSingleSuccessBridgeResult(params);
    }
}
```



