
package com.bytedance.transbridge.codec;

import com.bytedance.transbridge.utils.GsonUtils;

import java.nio.ByteBuffer;

import io.flutter.plugin.common.StringCodec;

public class GsonMessageCodec {
    public static final GsonMessageCodec INSTANCE = new GsonMessageCodec();

    private GsonMessageCodec() {
    }

    public ByteBuffer encodeMessage(Object message) {
        if (message == null) {
            return null;
        } else {
            return StringCodec.INSTANCE.encodeMessage(GsonUtils.toJson(message));
        }
    }

    public Object decodeMessage(ByteBuffer message) {
        if (message == null) {
            return null;
        } else {
            String json = StringCodec.INSTANCE.decodeMessage(message);
            return GsonUtils.fromJson(json);
        }
    }
}




