package com.example.bridge_client_example;

import android.os.Bundle;
import android.widget.Toast;

import com.bytedance.transbridge.core.IBridgeContext;
import com.bytedance.transbridge.core.IBridgeHost;
import com.bytedance.transbridge.core.IBridgeResult;
import com.bytedance.transbridgefluimpl.Bridges;
import com.bytedance.transbridgefluimpl.annotations.SubMethod;
import com.bytedance.transbridgefluimpl.models.BridgeMethods;
import com.bytedance.transbridgefluimpl.models.BridgeResult;
import com.google.gson.Gson;
import com.google.gson.JsonObject;

import java.util.Arrays;

import io.flutter.app.FlutterActivity;
import io.reactivex.Single;

public class MainActivity extends FlutterActivity {

//    public class ToastMethod extends BridgeMethods.PublicMethod {
//        @Override
//        public Single<IBridgeResult> call(IBridgeContext context, JsonObject params) {
//            Toast.makeText(getApplicationContext(), params.get("message").getAsString(), Toast.LENGTH_SHORT).show();
//            return BridgeResult.createSingleSuccessBridgeResult(params);
//        }
//    }

    static class TestBase {
        byte[] bytes;

        public TestBase(byte[] bytes) {
            this.bytes = bytes;
        }
    }

    public class UI extends BridgeMethods.ComposeMethod {
        public UI() {
//            registerSubMethod("toast", toast);
        }

        //        @SubMethod
//        public IBridgeMethod toast = new BridgeMethods.PublicMethod() {
//            @Override
//            public Single<IBridgeResult> call(IBridgeContext context, String name, JsonObject params) {
//                Toast.makeText(getApplicationContext(), params.get("message").getAsString(), Toast.LENGTH_SHORT).show();
//                return BridgeResult.createSingleSuccessBridgeResult(params);
//            }
//        };
        @SubMethod
        public Single<IBridgeResult> toast(IBridgeContext context, String name, JsonObject params) {
            Toast.makeText(getApplicationContext(), params.get("message").getAsString(), Toast.LENGTH_SHORT).show();
            FlutterBridge.getInstance().sendEvent(getFlutterView(), "test", new byte[]{1, 2, 3, 4, 5, 6}, origin -> origin);
            return BridgeResult.createSingleSuccessBridgeResult(new byte[]{0, 1, 2, 3, 4});
        }
    }

    public class Standard extends BridgeMethods.ComposeMethod {
        @SubMethod
        public Single<IBridgeResult> toast(IBridgeContext context, String name, JsonObject params) {
//            Toast.makeText(getApplicationContext(), params.get("message").getAsString(), Toast.LENGTH_SHORT).show();
            String a1 = new Gson().toJson(new TestBase(new byte[]{1, 2, 3, 4, 5}));
            TestBase a2 = new Gson().fromJson(a1, TestBase.class);
            System.out.println(a2.toString());
//            FlutterBridge.getInstance().sendEvent(getFlutterView(), "test", new byte[]{1, 2, 3, 4, 5, 6}, origin -> origin);
            return BridgeResult.createSingleSuccessBridgeResult(new byte[]{0, 1, 2, 3, 4});
        }
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//        FlutterBridge.getInstance().addMethod("TTRUI.toast", new ToastMethod());
        // 需要 Annotation 就使用传 class 的 api，如果不需要，直接传 name, compose method.
        Bridges.getInstance().register("TTRUI", UI.class, new UI());
        Bridges.getInstance().register("TTRStandard", Standard.class, new Standard());
        FlutterBridge.getInstance().delegate(this, getFlutterView());
    }
}
