package com.example.bridge_client_example.utils;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonElement;
import com.google.gson.JsonParser;

public final class GsonUtils {
    private GsonUtils() throws IllegalAccessException {
        throw new IllegalAccessException("illegal access constructor");
    }

    public static Gson gson = new GsonBuilder().create();

    public static <T> String toJson(T obj) {
        return gson.toJson(obj);
    }

    public static <T> JsonElement toJsonElement(T obj) {
        return gson.toJsonTree(obj);
    }

    public static <T> T fromJson(String obj, Class<T> classOfT) {
        return gson.fromJson(obj, classOfT);
    }

    public static Gson getGson() {
        return gson;
    }

    public static JsonElement fromJson(String json) {
        return JsonParser.parseString(json);
    }
}
